/*:
## Aufgabe Don’t touch – Level 2
*/

/**
Verwaltet die Spielfigur

- author: Klaus Reinold
- version: 1.0
*/
class Spielfigur: Figur
{
//#-hidden-code
    /** Länge der Bewegung */
    var delta: Int
    /** Anzeigetext */
    var t: Text!

    /**
    Legt das Aussehen der Spielfigur fest
    */
    override init()
    {
        delta = 4
        t = nil
        super.init()
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 100, höhe: 100, farbe: "rot")
    }
    
    /**
    Tasten werden ignoriert
    - parameters:
        - taste: die gedrückte Taste
    */
    override func TasteGedrückt (taste: Character)
    {
    }

    /**
    Sondertasten werden ausgewertet
    - parameters:
        - taste: die gedrückte Taste
    */
    override func SonderTasteGedrückt (taste: Int)
    {
        if taste == 126
        {
            if YPositionGeben()>0
            {
                PositionSetzen(x: XPositionGeben(),y: YPositionGeben()-delta)
            }
        }
        if taste == 125
        {
            if YPositionGeben()<500
            {
                PositionSetzen(x: XPositionGeben(),y: YPositionGeben()+delta)
            }
        }
        if taste == 123
        {
            if XPositionGeben()>0
            {
                PositionSetzen(x: XPositionGeben()-delta,y: YPositionGeben())
            }
        }
        if taste == 124
        {
            if XPositionGeben()<740
            {
                PositionSetzen(x: XPositionGeben()+delta,y: YPositionGeben())
            }
        }

    }

    /**
    Bewegt die Figur.
    */
    override func AktionAusführen()
    {

        if Berührt()
        {
            if t != nil
            {
                t.Entfernen()
            }
            t = Text()
            t.TextSetzen(text: "Don't touch")

        }
        if t != nil
        {
            t.TextVergrößern()
            t.Verschieben(deltaX: 5,deltaY: 5)
        }
    }
}

/**
Klasse Hindernis

- author: Klaus Reinold
- version: 1.0
 */
class Hindernis: Figur
{
   
    /**
    Legt das Aussehen des Hindernisses an
	- parameters:
        - x:x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung Blickrichtung des Hindernisses
     */
    init(x: Int, y: Int, richtung: Character)
    {
        super.init()
        Zeichnen()
        PositionSetzen(x: x,y: y)
        RichtungSetzen(richtung: richtung)
    }

    /**
    Bewegt das Hindernis
    */
    override func AktionAusführen()
    {
        Bewegen()
    }
    
    /**
    Tasten werden ignoriert
    - parameters:
        - taste: die gedrückte Taste
    */
    override func TasteGedrückt (taste: Character)
    {
    }
    
    /**
    Sondertasten werden ignoriert
    - parameters:
        - taste: die gedrückte Taste
    */
    override func SonderTasteGedrückt (taste: Int)
    {
    }
    
    /**
    Lässt das Hindernis um 5 Einheiten gehen
    */
    func Bewegen()
    {
        Gehen(länge: 5)
    }
    
    /**
    Legt Form und Größe des Hindernisses fest
    */
    func Zeichnen()
    {
        FigurteilFestlegenRechteck(x: 0, y: 0, breite: 100, höhe: 500, farbe: "grün")
        GrößeSetzen(größe: 50)
        PositionSetzen(x: 700,y: 200)
    }
    
    /**
    Setzt die Blickrichtuing des Hindernisses
	- parameters:
        - richtung Blickrichtung des Hindernisses
    */
    func RichtungSetzen(richtung: Character)
    {
        if richtung == "O"
        {
            //nichts
        }
        else
        {
            if richtung == "N"
            {
                Drehen(grad: 90)
            }
            else
            {
                if richtung == "W"
                {
                    Drehen(grad: 180)
                }
                else
                {
                    if richtung == "S"
                    {
                        Drehen(grad: 270)
                    }
                    else
                    {
                        print("Fehlerhafte Richtung in Konstruktor von Hindernis");
                    }
                }
            }
        }
    }
    
    /**
    Entfernt das Hindernis, wenn es die Zeichenfläche verlässt
    */
    func EntfernenWennAußerhalb()
    {
        if (XPositionGeben() < -100) || (XPositionGeben() > 900) || (YPositionGeben() < -100) || (YPositionGeben() > 700)
        {
            Entfernen()
        }
    }
//#-end-hidden-code
}

/**
Klasse Rotor

- author: Klaus Reinold
- version: 1.0
*/
class Rotor: Hindernis
{
    /** die aktuelle Blickrichtung */
    var richtung: Character

    /**
    Legt das Aussehen und die Startposition fest
	- parameters:
        - x:x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung Blickrichtung des Hindernisses
    */
    override init(x: Int, y: Int, richtung: Character)
    {
        self.richtung = richtung
        super.init(x: x,y: y,richtung: richtung)

        Zeichnen()
        RichtungSetzen(richtung: richtung)
        PositionSetzen(x: x,y: y)
    }
    
    /**
    Rotiert das Hindernis
    */
    override func Bewegen()
    {
        Drehen(grad: 5)
        if richtung == "N"
        {
            PositionSetzen(x: XPositionGeben(),y: YPositionGeben()-5)
        }
        else
        {
            if richtung == "S"
            {
                PositionSetzen(x: XPositionGeben(),y: YPositionGeben()+5)
            }
            else
            {
                if richtung == "O"
                {
                    PositionSetzen(x: XPositionGeben()+5,y: YPositionGeben())
                }
                else
                {
                    if richtung == "W"
                    {
                        PositionSetzen(x: XPositionGeben()-5,y: YPositionGeben())
                    }
                    else
                    {
                        print("unbekannte Richtung in Methode Bewegen, Klasse Hindernis")
                    }
                }
            }
        }
        EntfernenWennAußerhalb();
    }

    /**
    Legt Form und Größe des Hindernisses fest
    */
    override func Zeichnen()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenDreieck(x1: 0,y1: 0,x2: 0,y2: 100,x3: 100,y3: 50,farbe: "gelb")
        FigurteilFestlegenEllipse(x: 30,y: 30,breite: 40,höhe: 40,farbe: "blau")
        GrößeSetzen(größe: 60)
    }
}

/**
Klasse Zickezacke.

- author: Klaus Reinold
- version: 1.0
*/
class Zickezacke: Hindernis
{
    /** Zählt die grmachten Zacks */
    var zackenzähler: Int
    /** Der Drehwinkel */
    var winkel: Int

    /**
    Legt das Aussehen und die Startposition fest
	- parameters:
        - x:x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung Blickrichtung des Hindernisses
    */
    override init(x: Int, y: Int, richtung: Character)
    {
        winkel = 45
        zackenzähler = 5
        super.init(x: x,y: y,richtung: richtung)
        Zeichnen()
        RichtungSetzen(richtung: richtung)
        Drehen(grad: winkel)
        PositionSetzen(x: x,y: y)
    }
    
    /**
    Führt dei Zickzackbewegung durch
    */
    override func Bewegen()
    {
        if(zackenzähler == 0)
        {
            if winkel==45
            {
                winkel = -45
                Drehen(grad: -90)
            }
            else
            {
                winkel = 45
                Drehen(grad: 90)
            }
            zackenzähler = 9
        }
        else
        {
            Gehen(länge: 5)
            zackenzähler = zackenzähler - 1
        }
        EntfernenWennAußerhalb()
    }
    
    /**
    Legt Form und Größe des Hindernisses fest
    */
    override func Zeichnen()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenDreieck(x1: -50,y1: -50,x2: 50,y2: 0,x3: -50,y3: 50,farbe: "magenta")
        GrößeSetzen(größe: 40)
    }
}

/**
Klasse Quadrat
 
- author: Klaus Reinold
- version: 1.0
*/
class Quadrat: Hindernis
{
    /**
    Legt das Aussehen und die Startposition fest
	- parameters:
        - x:x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung Blickrichtung des Hindernisses
    */
    override init(x: Int, y: Int, richtung: Character)
    {
        super.init(x: x,y: y,richtung: richtung)
        Zeichnen()
    }

    /**
    Lässt das Hindernis um 20 Einheiten gehen
    */
    override func Bewegen()
    {
        Gehen(länge: 20)
        EntfernenWennAußerhalb()
    }

    /**
    Legt Form und Größe des Hindernisses fest
    */
    override func Zeichnen()
    {
        super.EigeneFigurLöschen()

        FigurteilFestlegenRechteck(x: -50, y: -50, breite: 100, höhe: 100, farbe: "magenta")
        FigurteilFestlegenRechteck(x: -40, y: -40, breite: 80, höhe: 80, farbe: "hellgrün")
        FigurteilFestlegenRechteck(x: -30, y: -30, breite: 60, höhe: 60, farbe: "gelb")
        FigurteilFestlegenRechteck(x: -20, y: -20, breite: 40, höhe: 40, farbe: "blau")
        FigurteilFestlegenRechteck(x: -10, y: -10, breite: 20, höhe: 20, farbe: "orange")
    }
}

/**
Klasse Schlagbaum

- author: Klaus Reinold
- version: 1.0
*/
class Schlagbaum: Hindernis
{
    /**
    Legt das Aussehen und die Startposition fest
	- parameters:
        - x:x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung Blickrichtung des Hindernisses
    */
    override init(x: Int, y: Int, richtung: Character)
    {
        super.init(x: x,y: y,richtung: richtung)
        Zeichnen()
        RichtungSetzen(richtung: richtung)
        PositionSetzen(x: x,y: y)
    }

    /**
    Lässt das Hindernis um 5 Einheiten gehen
    */
   override func Bewegen()
    {
        Gehen(länge: 5)
    	EntfernenWennAußerhalb()
    }
    
    /**
    Legt Form und Größe des Hindernisses fest
    */
    override func Zeichnen()
    {
        EigeneFigurLöschen()
        var i = 0
        while i < 5
        {
            FigurteilFestlegenRechteck(x: i*20-50,y: -5,breite: 10,höhe: 10,farbe: "rot")
            FigurteilFestlegenRechteck(x: 10+i*20-50,y: -5,breite: 10,höhe: 10,farbe: "weiß")
            GrößeSetzen(größe: 100)
            i = i + 1
        }
    }
}
/**
Klasse Stern

- author: Klaus Reinold
- version: 1.0
*/
class Stern: Hindernis
{
    /** Der Drehwinkel */
    var winkel: Int

    /**
    Legt das Aussehen und die Startposition fest
	- parameters:
        - x:x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung Blickrichtung des Hindernisses
    */
    override init(x: Int, y: Int, richtung: Character)
    {
        winkel = 0
        super.init(x: x,y: y,richtung: richtung)
        if richtung == "N"
        {
            winkel = 10
        }
        else
        {
            if richtung == "S"
            {
                winkel = 190
            }
            else
            {
                if richtung == "O"
                {
                    winkel = 80
                }
                else
                {
                    if richtung == "W"
                    {
                        winkel = 260
                    }
                    else
                    {
                        print("unbekannte Richtung in Methode Bewegen, Klasse Hindernis")
                    }
                }
            }
        }
        WinkelSetzen(winkel: winkel)
        Zeichnen()
    }
    
    /**
    Reflektiert das Hindernis
    */
    override func Bewegen()
    {
        if winkel == 10
        {
            if XPositionGeben() > 890
            {
                winkel = 170
            }
        }
        else
        {
            if winkel == 170
            {
                if XPositionGeben() < 10
                {
                    winkel = 10
                }
            }
            else
            {
                if winkel == 350
                {
                    if XPositionGeben() > 890
                    {
                        winkel = 190
                    }
                }
                else
                {
                    if winkel == 190
                    {
                        if XPositionGeben() < 10
                        {
                            winkel = 350
                        }
                    }
                    else
                    {
                        if winkel == 80
                        {
                            if YPositionGeben() < 10
                            {
                                winkel = 280
                            }
                        }
                        else
                        {
                            if winkel == 280
                            {
                                if YPositionGeben() > 690
                                {
                                    winkel = 80
                                }
                            }
                            else
                            {
                                if winkel == 100
                                {
                                    if YPositionGeben() < 10
                                    {
                                        winkel = 260
                                    }
                                }
                                else
                                {
                                    if winkel == 260
                                    {
                                        if YPositionGeben() > 690
                                        {
                                            winkel = 100
                                        }
                                    }
                                    else
                                    {
                                        print("unbekannte Richtung in Methode Bewegen, Klasse Hindernis")
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        WinkelSetzen(winkel: winkel)
        Gehen(länge: 5)
        EntfernenWennAußerhalb()
    }

    /**
    Legt Form und Größe des Hindernisses fest
    */
    override func Zeichnen()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenDreieck(x1: -25, y1: -50, x2: 50, y2: 0, x3: -25, y3: 50, farbe: "grün")
        FigurteilFestlegenDreieck(x1: 25, y1: -50, x2: -50, y2: 0, x3: 25, y3: 50, farbe: "grün")
        GrößeSetzen(größe: 60)
    }
}





//#-editable-code



//#-end-editable-code

//#-editable-code



//#-end-editable-code

/**
Legt das Spielszenario fest

- author: Klaus Reinold
- version: 1.0
*/
class Spiel: Ereignisbehandlung
{
    /** Zufallsgenerator */
    var zzgenerator: Zufall
    /** Taktzähler */
    var zähler: Int
    
    /**
    Legt die Spielfigur und den Zufallsgenertor an
    */
    override init()
    {
        zähler = 8
        zzgenerator = Zufall()
        super.init()
        Spielfigur()
        TaktdauerSetzen(dauer: 400)
    }

    /**
    Legt neue Hindernisse an
    */
    override func TaktImpulsAusführen ()
    {
        if zähler<3
        {
            zähler = zähler + 1
        }
        else
        {
            HindernisErzeugen()
            zähler = 0
        }
    }
    
    /**
    Tasten werden ignoriert
    - parameters:
        - taste: die gedrückte Taste
    */
    override func TasteGedrückt (taste: Character)
    {
    }
    
    /**
    Sondertasten werden ignoriert
    - parameters:
        - taste: die gedrückte Taste
    */
    override func SonderTasteGedrückt (taste: Int)
    {
    }

    /**
    Erzeugt ein Hindernis mit zufälliger Position und Richtung
    */
    func HindernisErzeugen()
    {
        let zufall = zzgenerator.ZufallGanz(top: 4)
        if zufall == 0
        {
            HindernisErzeugen(x: 0,y: zzgenerator.ZufallGanz(top: 600),richtung: "O")
        }
        else
        {
            if zufall == 1
            {
                HindernisErzeugen(x: 800,y: zzgenerator.ZufallGanz(top: 600),richtung: "W")
            }
            else
            {
                if zufall == 2
                {
                    HindernisErzeugen(x: zzgenerator.ZufallGanz(top: 800),y: 0,richtung: "S")
                }
                else
                {
                    if zufall == 3
                    {
                        HindernisErzeugen(x: zzgenerator.ZufallGanz(top: 800),y: 600,richtung: "N")
                    }
                    else
                    {
                        print("Fehler in Spiel, HindernisErzeugen()")
                    }
                }
            }
        }
    }
    
    /**
    Erzeugt ein zufälliges Hindernis
	- parameters:
        - x: x-Koordinate des Hindernisses
        - y: y-Koordinate des Hindernisses
        - richtung: Blickrichtung des Hindernisses
     */
    func HindernisErzeugen(x: Int, y: Int, richtung: Character)
    {
//#-editable-code
        //Für eine neue Art von Hindernis musst du Obergrenze der Zufallszahl um eins erhöhen.
        //Füge dann einen neuen Fall für deine Klasse hinzu.
        let zufall = zzgenerator.ZufallGanz(top: 5)
        if zufall == 0
        {
            Zickezacke(x: x, y: y, richtung: richtung)
        }
        else
        {
            if zufall == 1
            {
                Quadrat(x: x, y: y, richtung: richtung)
            }
            else
            {
                if zufall == 2
                {
                    Schlagbaum(x: x, y: y, richtung: richtung)
                }
                else
                {
                    if zufall == 3
                    {
                        Rotor(x: x, y: y, richtung: richtung)
                    }
                    else
                    {
                        if zufall == 4
                        {
                        	Stern(x: x, y: y, richtung: richtung)
                        }
                        else
                        {
                            print("Fehler in Spiel, HindernisErzeugen()")
                        }
                    }
                }
            }
        }
    }
//#-end-editable-code
}


//#-editable-code
Spiel()
//#-end-editable-code
