/*:
## Aufgabe Krümel und Monster (Teil 3)
*/
/**
Verwaltet das Monster

- author: Albert Wiedemann
- version: 1.0
 */
class Monster: Figur
{
    /**
    Stellt das gelb gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGelb()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "gelb")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das orange gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenOrange()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "orange")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das rot gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenRot()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "rot")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das grün gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGrün()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "grün")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das Monster in der angegebenen Farbe mit offenem Mund dar.
    - parameters:
    	- farbe: die gewünschte Farbe
    */
    func Offen(farbe: String)
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: farbe)
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 50, y2: -10, x3: 50, y3: 10, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das in einer der Farben gelb, orange, rot bzw. grün mit geschlossenem Mund dar.
	- parameters:
    	- farbe: die gewünschte Farbe
     */
    func Schließen(farbe: String)
    {
        if farbe == "gelb"
        {
            GeschlossenGelb()
        }
        if farbe == "orange"
        {
            GeschlossenOrange()
        }
        if farbe == "rot"
        {
            GeschlossenRot()
        }
        if farbe == "grün"
        {
            GeschlossenGrün()
        }
    }

    /**
    Stellt das in einer der Farben gelb, orange, rot bzw. grün mit offenem Mund dar.
	- parameters:
    	- farbe: die gewünschte Farbe
    */
    func Öffnen(farbe: String)
    {
        if (farbe == "gelb") || (farbe == "orange") || (farbe == "rot") || (farbe == "grün")
        {
            Offen(farbe: farbe)
        }
    }

/*:
a\
Überschreibe in der Klasse MONSTER die Methode zunächst so,
dass jeder Tastendruck die Monster-Figur um 10 Einheiten nach vorn bewegt.*/
//#-editable-code


//#-end-editable-code
/*:
b\
Überschreibe nun in der Klasse MONSTER die Methode so, dass
- ein Drücken der Taste „↑“ die Monster-Figur nach Norden ausrichtet,
- ein Drücken der Taste „→“ die Monster -Figur nach Osten ausrichtet,
- ein Drücken der Taste „←“Monster-Figur nach Westen ausrichtet und
- ein Drücken der Taste „↓“Monster-Figur nach Süden ausrichtet.*/
//#-editable-code


//#-end-editable-code
/*:c\
Überschreibe in der Klasse MONSTER die Methode so, dass die Monster-Figur um 10 Einheiten nach vorn geht.\
d\
Ergänze die Methode  so, dass die Figur den sichtbaren Bereich der Zeichenfläche nicht überschreitet.*/
//#-editable-code


//#-end-editable-code
}

//#-editable-code


//#-end-editable-code

//#-editable-code


//#-end-editable-code
//#-editable-code
let monster = Monster()
monster.Öffnen(farbe: "gelb")
//#-end-editable-code

